/*----- PROTECTED REGION ID(DataVampireClass.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        DataVampireClass.h
//
// description : Include for the DataVampire root class.
//               This class is the singleton class for
//                the DataVampire device class.
//               It contains all properties and methods which the
//               DataVampire requires only once e.g. the commands.
//
// project :     DataVampire
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef DataVampireClass_H
#define DataVampireClass_H

#include <tango/tango.h>
#include "DataVampire.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	DataVampireClass.h


namespace DataVampire_ns
{
/*----- PROTECTED REGION ID(DataVampireClass::classes for dynamic creation) ENABLED START -----*/
/* clang-format on */

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	DataVampireClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute MinThreshold class definition
class MinThresholdAttrib: public Tango::Attr
{
public:
	MinThresholdAttrib():Attr("MinThreshold",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~MinThresholdAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_MinThreshold(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_MinThreshold(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_MinThreshold_allowed(ty);}
};

//	Attribute MaxThreshold class definition
class MaxThresholdAttrib: public Tango::Attr
{
public:
	MaxThresholdAttrib():Attr("MaxThreshold",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~MaxThresholdAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_MaxThreshold(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_MaxThreshold(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_MaxThreshold_allowed(ty);}
};

//	Attribute CommandString class definition
class CommandStringAttrib: public Tango::Attr
{
public:
	CommandStringAttrib():Attr("CommandString",
			Tango::DEV_STRING, Tango::READ_WRITE) {};
	~CommandStringAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_CommandString(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_CommandString(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_CommandString_allowed(ty);}
};

//	Attribute PollingPeriod class definition
class PollingPeriodAttrib: public Tango::Attr
{
public:
	PollingPeriodAttrib():Attr("PollingPeriod",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~PollingPeriodAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_PollingPeriod(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_PollingPeriod(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_PollingPeriod_allowed(ty);}
};

//	Attribute PollingSamples class definition
class PollingSamplesAttrib: public Tango::Attr
{
public:
	PollingSamplesAttrib():Attr("PollingSamples",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~PollingSamplesAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_PollingSamples(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_PollingSamples(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_PollingSamples_allowed(ty);}
};

//	Attribute Sum class definition
class SumAttrib: public Tango::Attr
{
public:
	SumAttrib():Attr("Sum",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~SumAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_Sum(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_Sum_allowed(ty);}
};

//	Attribute Mean class definition
class MeanAttrib: public Tango::Attr
{
public:
	MeanAttrib():Attr("Mean",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~MeanAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_Mean(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_Mean_allowed(ty);}
};

//	Attribute HorPos class definition
class HorPosAttrib: public Tango::Attr
{
public:
	HorPosAttrib():Attr("HorPos",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~HorPosAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_HorPos(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_HorPos_allowed(ty);}
};

//	Attribute VerPos class definition
class VerPosAttrib: public Tango::Attr
{
public:
	VerPosAttrib():Attr("VerPos",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~VerPosAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_VerPos(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_VerPos_allowed(ty);}
};

//	Attribute HorPosStd class definition
class HorPosStdAttrib: public Tango::Attr
{
public:
	HorPosStdAttrib():Attr("HorPosStd",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~HorPosStdAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_HorPosStd(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_HorPosStd_allowed(ty);}
};

//	Attribute ValidValues class definition
class ValidValuesAttrib: public Tango::Attr
{
public:
	ValidValuesAttrib():Attr("ValidValues",
			Tango::DEV_LONG, Tango::READ) {};
	~ValidValuesAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_ValidValues(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_ValidValues_allowed(ty);}
};

//	Attribute EnableAcquisition class definition
class EnableAcquisitionAttrib: public Tango::Attr
{
public:
	EnableAcquisitionAttrib():Attr("EnableAcquisition",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~EnableAcquisitionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_EnableAcquisition(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_EnableAcquisition(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_EnableAcquisition_allowed(ty);}
};

//	Attribute CacheSize class definition
class CacheSizeAttrib: public Tango::Attr
{
public:
	CacheSizeAttrib():Attr("CacheSize",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~CacheSizeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_CacheSize(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_CacheSize(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_CacheSize_allowed(ty);}
};

//	Attribute AutoBackgroundSamples class definition
class AutoBackgroundSamplesAttrib: public Tango::Attr
{
public:
	AutoBackgroundSamplesAttrib():Attr("AutoBackgroundSamples",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~AutoBackgroundSamplesAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_AutoBackgroundSamples(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_AutoBackgroundSamples(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_AutoBackgroundSamples_allowed(ty);}
};

//	Attribute PostAcqRoi class definition
class PostAcqRoiAttrib: public Tango::Attr
{
public:
	PostAcqRoiAttrib():Attr("PostAcqRoi",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~PostAcqRoiAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_PostAcqRoi(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_PostAcqRoi(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_PostAcqRoi_allowed(ty);}
};

//	Attribute Width class definition
class WidthAttrib: public Tango::Attr
{
public:
	WidthAttrib():Attr("Width",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~WidthAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_Width(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_Width(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_Width_allowed(ty);}
};

//	Attribute Height class definition
class HeightAttrib: public Tango::Attr
{
public:
	HeightAttrib():Attr("Height",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~HeightAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_Height(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_Height(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_Height_allowed(ty);}
};

//	Attribute VerPosStd class definition
class VerPosStdAttrib: public Tango::Attr
{
public:
	VerPosStdAttrib():Attr("VerPosStd",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~VerPosStdAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_VerPosStd(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_VerPosStd_allowed(ty);}
};

//	Attribute EnablePolling class definition
class EnablePollingAttrib: public Tango::Attr
{
public:
	EnablePollingAttrib():Attr("EnablePolling",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~EnablePollingAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_EnablePolling(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_EnablePolling(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_EnablePolling_allowed(ty);}
};

//	Attribute BackgroundSamples class definition
class BackgroundSamplesAttrib: public Tango::Attr
{
public:
	BackgroundSamplesAttrib():Attr("BackgroundSamples",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~BackgroundSamplesAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_BackgroundSamples(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_BackgroundSamples(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_BackgroundSamples_allowed(ty);}
};

//	Attribute RoiParam class definition
class RoiParamAttrib: public Tango::SpectrumAttr
{
public:
	RoiParamAttrib():SpectrumAttr("RoiParam",
			Tango::DEV_LONG, Tango::READ_WRITE, 4) {};
	~RoiParamAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_RoiParam(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<DataVampire *>(dev))->write_RoiParam(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_RoiParam_allowed(ty);}
};

//	Attribute Spectrum class definition
class SpectrumAttrib: public Tango::SpectrumAttr
{
public:
	SpectrumAttrib():SpectrumAttr("Spectrum",
			Tango::DEV_DOUBLE, Tango::READ, 1000000) {};
	~SpectrumAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_Spectrum(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_Spectrum_allowed(ty);}
};

//	Attribute HorBackground class definition
class HorBackgroundAttrib: public Tango::SpectrumAttr
{
public:
	HorBackgroundAttrib():SpectrumAttr("HorBackground",
			Tango::DEV_DOUBLE, Tango::READ, 1000000) {};
	~HorBackgroundAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_HorBackground(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_HorBackground_allowed(ty);}
};

//	Attribute VerBackground class definition
class VerBackgroundAttrib: public Tango::SpectrumAttr
{
public:
	VerBackgroundAttrib():SpectrumAttr("VerBackground",
			Tango::DEV_DOUBLE, Tango::READ, 1000000) {};
	~VerBackgroundAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_VerBackground(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_VerBackground_allowed(ty);}
};

//	Attribute Image class definition
class ImageAttrib: public Tango::ImageAttr
{
public:
	ImageAttrib():ImageAttr("Image",
			Tango::DEV_DOUBLE, Tango::READ, 5000, 5000) {};
	~ImageAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<DataVampire *>(dev))->read_Image(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<DataVampire *>(dev))->is_Image_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command GetSum class definition
class GetSumClass : public Tango::Command
{
public:
	GetSumClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetSumClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetSumClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<DataVampire *>(dev))->is_GetSum_allowed(any);}
};

//	Command GetMean class definition
class GetMeanClass : public Tango::Command
{
public:
	GetMeanClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetMeanClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetMeanClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<DataVampire *>(dev))->is_GetMean_allowed(any);}
};

//	Command GetHorPos class definition
class GetHorPosClass : public Tango::Command
{
public:
	GetHorPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetHorPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetHorPosClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<DataVampire *>(dev))->is_GetHorPos_allowed(any);}
};

//	Command GetVerPos class definition
class GetVerPosClass : public Tango::Command
{
public:
	GetVerPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetVerPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetVerPosClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<DataVampire *>(dev))->is_GetVerPos_allowed(any);}
};

//	Command GetHorPosStd class definition
class GetHorPosStdClass : public Tango::Command
{
public:
	GetHorPosStdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetHorPosStdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetHorPosStdClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<DataVampire *>(dev))->is_GetHorPosStd_allowed(any);}
};

//	Command GetVerPosStd class definition
class GetVerPosStdClass : public Tango::Command
{
public:
	GetVerPosStdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetVerPosStdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetVerPosStdClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<DataVampire *>(dev))->is_GetVerPosStd_allowed(any);}
};

//	Command GetValidValues class definition
class GetValidValuesClass : public Tango::Command
{
public:
	GetValidValuesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetValidValuesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetValidValuesClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<DataVampire *>(dev))->is_GetValidValues_allowed(any);}
};

//	Command SetBackground class definition
class SetBackgroundClass : public Tango::Command
{
public:
	SetBackgroundClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetBackgroundClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetBackgroundClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<DataVampire *>(dev))->is_SetBackground_allowed(any);}
};


/**
 *	The DataVampireClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  DataVampireClass : public Tango::DeviceClass
#else
class DataVampireClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(DataVampireClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	DataVampireClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static DataVampireClass *init(const char *);
		static DataVampireClass *instance();
		~DataVampireClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		DataVampireClass(string &);
		static DataVampireClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	DataVampire_H
